# coding: utf-8

"""
    Cloudsmith API

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class RepositoryPrivilegeInputPrivileges(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'privilege': 'str',
        'team': 'str',
        'user': 'str'
    }

    attribute_map = {
        'privilege': 'privilege',
        'team': 'team',
        'user': 'user'
    }

    def __init__(self, privilege=None, team=None, user=None, _configuration=None):  # noqa: E501
        """RepositoryPrivilegeInputPrivileges - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._privilege = None
        self._team = None
        self._user = None
        self.discriminator = None

        if privilege is not None:
            self.privilege = privilege
        if team is not None:
            self.team = team
        if user is not None:
            self.user = user

    @property
    def privilege(self):
        """Gets the privilege of this RepositoryPrivilegeInputPrivileges.

        The level of privilege that the user or team should be granted to the specified repository.

        :return: The privilege of this RepositoryPrivilegeInputPrivileges.
        :rtype: str
        """
        return self._privilege

    @privilege.setter
    def privilege(self, privilege):
        """Sets the privilege of this RepositoryPrivilegeInputPrivileges.

        The level of privilege that the user or team should be granted to the specified repository.

        :param privilege: The privilege of this RepositoryPrivilegeInputPrivileges.
        :type: str
        """

        self._privilege = privilege

    @property
    def team(self):
        """Gets the team of this RepositoryPrivilegeInputPrivileges.

        The team identifier (slug).

        :return: The team of this RepositoryPrivilegeInputPrivileges.
        :rtype: str
        """
        return self._team

    @team.setter
    def team(self, team):
        """Sets the team of this RepositoryPrivilegeInputPrivileges.

        The team identifier (slug).

        :param team: The team of this RepositoryPrivilegeInputPrivileges.
        :type: str
        """

        self._team = team

    @property
    def user(self):
        """Gets the user of this RepositoryPrivilegeInputPrivileges.

        The user identifier (slug).

        :return: The user of this RepositoryPrivilegeInputPrivileges.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this RepositoryPrivilegeInputPrivileges.

        The user identifier (slug).

        :param user: The user of this RepositoryPrivilegeInputPrivileges.
        :type: str
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RepositoryPrivilegeInputPrivileges, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RepositoryPrivilegeInputPrivileges):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RepositoryPrivilegeInputPrivileges):
            return True

        return self.to_dict() != other.to_dict()

